Index: /bdm/user_info.cpp
===================================================================
--- /bdm/user_info.cpp (revision 351)
+++ /bdm/user_info.cpp (revision 357)
@@ -13,5 +13,6 @@
 #include "user_info.h"
 
-namespace bdm {
+namespace bdm
+{
 
 
@@ -19,45 +20,46 @@
 
 
-UI_File::UI_File ( const string &file_name ) : file_name( file_name )
-{
-	setAutoConvert( true );
+UI_File::UI_File ()
+{
+    setAutoConvert( true );
 }
 
 //! loads root element from a file
-void UI_File::load() 
-{
-	try
-	{
-		readFile( file_name.c_str()  );
-	}
-	catch ( FileIOException f ) 
-	{
-		it_error ( "UI error: file " + file_name + " not found." );
-	}
-	catch ( ParseException& P ) 
-	{
-		stringstream msg;
-		msg << "UI error: parsing ui_error """ << P.getError() << """ in file " << file_name << " on line " <<  P.getLine() << ".";
-		it_error ( msg.str() );
-	}	
+UI_File::UI_File ( const string &file_name )
+{
+    setAutoConvert( true );
+    try
+    {
+        readFile( file_name.c_str()  );
+    }
+    catch ( FileIOException f )
+    {
+        it_error ( "UI error: file " + file_name + " not found." );
+    }
+    catch ( ParseException& P )
+    {
+        stringstream msg;
+        msg << "UI error: parsing error """ << P.getError() << """ in file " << file_name << " on line " <<  P.getLine() << ".";
+        it_error ( msg.str() );
+    }
 }
 
 
 //! save UserInfo to the file (typically with an XML extension)
-void UI_File::save()
-{
-	try
-	{
-		writeFile ( file_name.c_str()  );
-	}
-	catch ( FileIOException f ) 
-	{
-		it_error( "UI error: file " + file_name + " is inacessible." );
-	}		
-}	
+void UI_File::save(  const string &file_name )
+{
+    try
+    {
+        writeFile ( file_name.c_str()  );
+    }
+    catch ( FileIOException f )
+    {
+        it_error( "UI error: file " + file_name + " is inacessible." );
+    }
+}
 
 UI_File::operator Setting&()
 {
-	return getRoot();
+    return getRoot();
 }
 ///////////////////////// INTERNAL MAPPED_UI /////////////////////////////////////////////
@@ -65,36 +67,36 @@
 UI::Mapped_UI::String_To_UI_Map& UI::Mapped_UI::mapped_strings()
 {
-	static String_To_UI_Map var;
-	return var;
+    static String_To_UI_Map var;
+    return var;
 }
 
 UI::Mapped_UI::Type_Info_To_String_Map& UI::Mapped_UI::mapped_type_infos()
 {
-	static Type_Info_To_String_Map var;
-	return var;
+    static Type_Info_To_String_Map var;
+    return var;
 }
 
 void UI::Mapped_UI::add_class( const string &class_name, const type_info * const class_type_info, const UI* const ui )
 {
-	pair< const string, const UI* const > new_pair = make_pair( class_name, ui );
-	mapped_strings().insert( new_pair );
-	mapped_type_infos().insert( make_pair( class_type_info, new_pair.first ) );
+    pair< const string, const UI* const > new_pair = make_pair( class_name, ui );
+    mapped_strings().insert( new_pair );
+    mapped_type_infos().insert( make_pair( class_type_info, new_pair.first ) );
 }
 
 const UI& UI::Mapped_UI::retrieve_ui( const string &class_name )
 {
-	String_To_UI_Map::const_iterator iter = mapped_strings().find( class_name );
-	if( iter == mapped_strings().end()) 
-		it_error ( "UI error: class " + class_name + " was not properly registered. Use the macro ""UIREGISTER([class name]);"" within your code." );
-	return *iter->second;
-}	
+    String_To_UI_Map::const_iterator iter = mapped_strings().find( class_name );
+    if ( iter == mapped_strings().end())
+        it_error ( "UI error: class " + class_name + " was not properly registered. Use the macro ""UIREGISTER([class name]);"" within your code." );
+    return *iter->second;
+}
 
 const string& UI::Mapped_UI::retrieve_class_name( const type_info * const class_type_info )
 {
-	Type_Info_To_String_Map::const_iterator iter = mapped_type_infos().find( class_type_info );
-	if( iter == mapped_type_infos().end()) 
-		it_error ( "UI error: class with RTTI name " + string(class_type_info->name()) + " was not properly registered. Use the macro ""UIREGISTER([class name]);"" within your code." );
-	return iter->second;
-}	
+    Type_Info_To_String_Map::const_iterator iter = mapped_type_infos().find( class_type_info );
+    if ( iter == mapped_type_infos().end())
+        it_error ( "UI error: class with RTTI name " + string(class_type_info->name()) + " was not properly registered. Use the macro ""UIREGISTER([class name]);"" within your code." );
+    return iter->second;
+}
 
 ///////////////////////// INTERNAL LINK EXPANDER /////////////////////////////////////////////
@@ -102,206 +104,291 @@
 UI::Link_Expander::Link_Expander( const Setting &potential_link )
 {
-	file = NULL;
-	result = &potential_link;
-
-	if( potential_link.getType() !=  Setting::TypeString )
-		return;
-
-	string link = (string) potential_link;
-	size_t aerobase = link.find('@');
-	if( aerobase != string::npos )
-	{
-		string file_name = link.substr( aerobase + 1, link.length() );
-		file = new UI_File( file_name );
-		file->load();
-		result = &(Setting&)(*file);
-		link = link.substr( 0, aerobase );
-	}
-	else
-		while ( !result->isRoot() ) 
-			result = &result->getParent();
-
-	if( !result->exists( link ) )
-		ui_error( "linked Setting was not found", potential_link );
-
-	result = &(*result)[link];
+    file = NULL;
+    result = &potential_link;
+
+    if ( potential_link.getType() !=  Setting::TypeString )
+        return;
+
+    string link = (string) potential_link;
+    size_t aerobase = link.find('@');
+    if ( aerobase != string::npos )
+    {
+        string file_name = link.substr( aerobase + 1, link.length() );
+        file = new UI_File( file_name );
+        result = &(Setting&)(*file);
+        link = link.substr( 0, aerobase );
+    }
+    else
+        while ( !result->isRoot() )
+            result = &result->getParent();
+
+    if ( !result->exists( link ) )
+        ui_error( "linked Setting was not found", potential_link );
+
+    result = &(*result)[link];
 }
 
 UI::Link_Expander::~Link_Expander()
 {
-	if( file ) delete file;
+    if ( file ) delete file;
 }
 
 const Setting& UI::Link_Expander::root() const
 {
-	return *result;
+    return *result;
 }
 
 ///////////////////////// UI /////////////////////////////////////////////
 
-
-
-//! This methods   - kvuli ukladani pole stringu, dat jen privatne?
+void UI::ui_error( string message, const Setting &element )
+{
+    stringstream error_message;
+    error_message << "UI error: " << message << "! Check path """ << element.getPath() << """, source line " << element.getSourceLine() << ".";
+    it_error ( error_message.str() );
+}
+
+//! This methods - kvuli ukladani pole stringu, dat jen privatne?
 void UI::save( const string &str, Setting &element )
 {
-	Setting &root = element.add( Setting::TypeString );
-	root = str;
+    Setting &root = element.add( Setting::TypeString );
+    root = str;
 }
 
 void UI::save( const mat &matrix, Setting &element, const string &name)
 {
-	
-	Setting &root = (name == "") ? element.add( Setting::TypeList )							
-								 : element.add( name, Setting::TypeList );		
-
-	Setting &cols = root.add( Setting::TypeInt );
-	cols = matrix.cols();
-
-	Setting &rows = root.add( Setting::TypeInt );
-	rows = matrix.rows();
-
-	Setting &elements = root.add( Setting::TypeArray );
-
-	// build matrix row-wise
-	for( int i=0; i<matrix.rows(); i++ ) 
-		for( int j=0; j<matrix.cols(); j++)
-		{
-			Setting &new_field = elements.add(Setting::TypeFloat);
-			new_field = matrix(i,j);
-		}
-}
-
-
-	//! This methods tries to save a double vec 
-void UI::save( const ivec &vec, Setting &element, const string &name)
-{
-	
-	Setting &root = (name == "") ? element.add( Setting::TypeArray )							
-								 : element.add( name, Setting::TypeArray );		
-	for( int i=0; i<vec.length(); i++ ) 
-	{
-		Setting &new_field = root.add(Setting::TypeInt);
-		new_field = vec(i);
-	}
-}
-
-
-//! This methods tries to build a new double matrix 
+
+    Setting &root = (name == "") ? element.add( Setting::TypeList )
+                    : element.add( name, Setting::TypeList );
+
+    Setting &cols = root.add( Setting::TypeInt );
+    cols = matrix.cols();
+
+    Setting &rows = root.add( Setting::TypeInt );
+    rows = matrix.rows();
+
+    Setting &elements = root.add( Setting::TypeArray );
+
+    // build matrix row-wise
+    for ( int i=0; i<matrix.rows(); i++ )
+        for ( int j=0; j<matrix.cols(); j++)
+        {
+            Setting &new_field = elements.add(Setting::TypeFloat);
+            new_field = matrix(i,j);
+        }
+}
+
+
+//! This methods tries to save a integer vector
+void UI::save( const ivec &vector, Setting &element, const string &name)
+{
+
+    Setting &root = (name == "") ? element.add( Setting::TypeArray )
+                    : element.add( name, Setting::TypeArray );
+    for ( int i=0; i<vector.length(); i++ )
+    {
+        Setting &new_field = root.add(Setting::TypeInt);
+        new_field = vector(i);
+    }
+}
+
+
+//! This methods tries to save a double vector
+void UI::save( const vec &vector, Setting &element, const string &name)
+{
+
+    Setting &root = (name == "") ? element.add( Setting::TypeArray )
+                    : element.add( name, Setting::TypeArray );
+    for ( int i=0; i<vector.length(); i++ )
+    {
+		Setting &new_field = root.add(Setting::TypeFloat);
+        new_field = vector(i);
+    }
+}
+
+
+//! This methods tries to build a new double matrix
 
 void UI::from_setting( mat& matrix, const Setting &element )
 {
-	const Link_Expander link_expander( element );
-	const Setting &root = link_expander.root();
-
-	if( root.isNumber() )
-	{
-		matrix.set_size( 1, 1 );
-		matrix(0,0) = root;
-		return;
-	}
-
-	if( root.isList() )
-	{
-		if( root.getLength() != 3 )
-			ui_error( "the setting supposed to represent a matrix element has wrong syntax", root );
-
-		Setting &cols_setting = root[0];
-		Setting &rows_setting = root[1];
-		Setting &elements = root[2];
-
-		ASSERT_UITYPE(cols_setting,TypeInt);
-		ASSERT_UITYPE(rows_setting,TypeInt);
-		ASSERT_UITYPE(elements,TypeArray);
-
-		int cols = cols_setting;
-		int rows = rows_setting;
-					
-		if( cols < 0 | rows < 0 )
-			ui_error( "the dimensions of a matrix has to be non-negative", root );
-
-		if( elements.getLength() != cols * rows )
-			ui_error( "the count of the matrix elements is incompatible with matrix dimension", elements );
-
-		matrix.set_size( rows, cols );
-
-		if( cols == 0 || rows == 0 )
-			return;
-
-		if( !elements[0].isNumber() )
-			ui_error( "matrix elements have to be numbers", elements[0] );
-
-		// build matrix row-wise
-		int k = 0;
-		for( int i=0;i<rows;i++ ) 
-			for( int j=0; j<cols; j++)
-				matrix(i,j) = elements[k++];
-		return;
-	}
-
-	ui_error( "only numeric types or TypeList are supported as matrix values", root );
+    const Link_Expander link_expander( element );
+    const Setting &root = link_expander.root();
+
+    if ( root.isNumber() )
+    {
+        matrix.set_size( 1, 1 );
+        matrix(0,0) = root;
+        return;
+    }
+
+    if ( root.isList() )
+    {
+        if ( root.getLength() != 3 )
+            ui_error( "the setting supposed to represent a matrix element has wrong syntax", root );
+
+        Setting &rows_setting = root[0];
+        Setting &cols_setting = root[1];
+        Setting &elements = root[2];
+
+        ASSERT_UITYPE(cols_setting,TypeInt);
+        ASSERT_UITYPE(rows_setting,TypeInt);
+        ASSERT_UITYPE(elements,TypeArray);
+
+        int cols = cols_setting;
+        int rows = rows_setting;
+
+        if ( cols < 0 | rows < 0 )
+            ui_error( "the dimensions of a matrix has to be non-negative", root );
+
+        if ( elements.getLength() != cols * rows )
+            ui_error( "the count of the matrix elements is incompatible with matrix dimension", elements );
+
+        matrix.set_size( rows, cols );
+
+        if ( cols == 0 || rows == 0 )
+            return;
+
+        if ( !elements[0].isNumber() )
+            ui_error( "matrix elements have to be numbers", elements[0] );
+
+        // build matrix row-wise
+        int k = 0;
+        for ( int i=0; i<rows; i++ )
+            for ( int j=0; j<cols; j++)
+                matrix(i,j) = elements[k++];
+        return;
+    }
+
+    ui_error( "only numeric types or TypeList are supported as matrix values", root );
 }
 
 //! This methods tries to build a new integer vector
-void UI::from_setting( ivec &vec, const Setting &element )
-{
-	const Link_Expander link_expander( element );
-	const Setting &root = link_expander.root();
-
-	if( root.isNumber() )
-	{
-		ASSERT_UITYPE(root,TypeInt);
-		vec.set_length( 1 );
-		vec(0) = root;
-		return;
-	}
-
-	if( root.isList() )
-	{
-		if( root.getLength() != 3 )
-			ui_error( "the setting supposed to represent a matrix element has wrong syntax", root );
-
-		Setting &cols_setting = root[0];
-		Setting &rows_setting = root[1];
-		Setting &elements = root[2];
-
-		ASSERT_UITYPE(cols_setting,TypeInt);
-		ASSERT_UITYPE(rows_setting,TypeInt);
-		ASSERT_UITYPE(elements,TypeArray);
-
-		int cols = cols_setting;
-		int rows = rows_setting;
-		
-		if( cols < 0 | rows < 0)
-			ui_error( "the dimensions of a matrix has to be non-negative", root );
-
-		if( elements.getLength() != cols * rows )
-			ui_error( "the count of the matrix elements is incompatible with matrix dimension", elements );
-
-		if( cols != 1 & rows !=1)
-			ui_error( "the vector length is invalid, it seems to be rather a matrix", elements );
-		
-		int len = rows * cols;
-		vec.set_length ( len );
-		if( len == 0 ) return;
-
-		ASSERT_UITYPE(elements[0],TypeInt);
-		for( int i=0; i<len; i++ ) 
-			vec(i) = elements[i];
-		return;
-	}
-
-	if( root.isArray() )
-	{	
-		int len = root.getLength();
-		vec.set_length( len );
-		if( len == 0 ) return;
-
-		ASSERT_UITYPE(root[0],TypeInt);
-		for( int i=0; i < len; i++ ) 
-			vec(i) = root[i];
-		return;
-	}
-
-	ui_error( "only numeric types, TypeArray or TypeList are supported as vector values", root );
+void UI::from_setting( ivec &vector, const Setting &element )
+{
+    const Link_Expander link_expander( element );
+    const Setting &root = link_expander.root();
+
+    if ( root.isNumber() )
+    {
+        ASSERT_UITYPE(root,TypeInt);
+        vector.set_length( 1 );
+        vector(0) = root;
+        return;
+    }
+
+    if ( root.isList() )
+    {
+        if ( root.getLength() != 3 )
+            ui_error( "the setting supposed to represent a matrix element has wrong syntax", root );
+
+        Setting &cols_setting = root[0];
+        Setting &rows_setting = root[1];
+        Setting &elements = root[2];
+
+        ASSERT_UITYPE(cols_setting,TypeInt);
+        ASSERT_UITYPE(rows_setting,TypeInt);
+        ASSERT_UITYPE(elements,TypeArray);
+
+        int cols = cols_setting;
+        int rows = rows_setting;
+
+        if ( cols < 0 | rows < 0)
+            ui_error( "the dimensions of a matrix has to be non-negative", root );
+
+        if ( elements.getLength() != cols * rows )
+            ui_error( "the count of the matrix elements is incompatible with matrix dimension", elements );
+
+        if ( cols != 1 & rows !=1)
+            ui_error( "the vector length is invalid, it seems to be rather a matrix", elements );
+
+        int len = rows * cols;
+        vector.set_length ( len );
+        if ( len == 0 ) return;
+
+        ASSERT_UITYPE(elements[0],TypeInt);
+        for ( int i=0; i<len; i++ )
+            vector(i) = elements[i];
+        return;
+    }
+
+    if ( root.isArray() )
+    {
+        int len = root.getLength();
+        vector.set_length( len );
+        if ( len == 0 ) return;
+
+        ASSERT_UITYPE(root[0],TypeInt);
+        for ( int i=0; i < len; i++ )
+            vector(i) = root[i];
+        return;
+    }
+
+    ui_error( "only numeric types, TypeArray or TypeList are supported as vector values", root );
+}
+
+//! This methods tries to build a new double vector
+void UI::from_setting( vec &vector, const Setting &element )
+{
+    const Link_Expander link_expander( element );
+    const Setting &root = link_expander.root();
+
+    if ( root.isNumber() )
+    {
+        vector.set_length( 1 );
+        vector(0) = root;
+        return;
+    }
+
+    if ( root.isList() )
+    {
+        if ( root.getLength() != 3 )
+            ui_error( "the setting supposed to represent a matrix element has wrong syntax", root );
+
+        Setting &cols_setting = root[0];
+        Setting &rows_setting = root[1];
+        Setting &elements = root[2];
+
+        ASSERT_UITYPE(cols_setting,TypeInt);
+        ASSERT_UITYPE(rows_setting,TypeInt);
+        ASSERT_UITYPE(elements,TypeArray);
+
+        int cols = cols_setting;
+        int rows = rows_setting;
+
+        if ( cols < 0 | rows < 0)
+            ui_error( "the dimensions of a matrix has to be non-negative", root );
+
+        if ( elements.getLength() != cols * rows )
+            ui_error( "the count of the matrix elements is incompatible with matrix dimension", elements );
+
+        if ( cols != 1 & rows !=1)
+            ui_error( "the vector length is invalid, it seems to be rather a matrix", elements );
+
+        int len = rows * cols;
+        vector.set_length ( len );
+        if ( len == 0 ) return;
+
+        if ( !elements[0].isNumber())
+            ui_error("a vector element has to be a number", elements[0]);
+
+        for ( int i=0; i<len; i++ )
+            vector(i) = elements[i];
+        return;
+    }
+
+    if ( root.isArray() )
+    {
+        int len = root.getLength();
+        vector.set_length( len );
+        if ( len == 0 ) return;
+
+        if ( !root[0].isNumber())
+            ui_error("a vector element has to be a number", root[0]);
+
+        for ( int i=0; i < len; i++ )
+            vector(i) = root[i];
+        return;
+    }
+
+    ui_error( "only numeric types, TypeArray or TypeList are supported as vector values", root );
 }
 
@@ -309,55 +396,33 @@
 void UI::from_setting( string &str, const Setting &element )
 {
-	ASSERT_UITYPE(element,TypeString);
-	str = (string) element;
+    ASSERT_UITYPE(element,TypeString);
+    str = (string) element;
 }
 
 
 ///////////////////////// UI FILE /////////////////////////////////////////////
-   	//! This methods tries to save an instance of type T (or some of its descendant types)
-	//! and build DOM tree accordingly. Then, it creates a new DOMNode named according class_name
-	//! and connecti it to the passed Setting as a new child node.
-const Setting* UI::pointer_to_child_setting( const Setting &element, const int index )
-{
-	if( !element.isList())
-		return NULL;
-
-	if( element.getLength() <= index )
-		return NULL;
-
-	return &element[index];
-}
-
-const Setting* UI::pointer_to_child_setting( const Setting &element, const string &name )
-{
-	if( !element.isGroup() )
-		return NULL;
-
-	if( !element.exists( name ) )
-		return NULL;
-
-	return &element[name];
-}
-
-const Setting& UI::reference_to_child_setting( const Setting &element, const int index )
-{
-	if( !element.isList())
-		ui_error( "only TypeList elements could be indexed by integers", element );
-
-	if( element.getLength() <= index )
-		ui_error( "there is not any child with index " + index, element );
-
-	return element[index];
-}
-
-const Setting& UI::reference_to_child_setting( const Setting &element, const string &name )
-{
-	ASSERT_UITYPE(element,TypeGroup);
-	if( !element.exists( name ) )
-		ui_error( "there is not any child named """ + name, element );
-	return element[name];
-}
-
-
-}
-
+//! This methods tries to save an instance of type T (or some of its descendant types)
+//! and build DOM tree accordingly. Then, it creates a new DOMNode named according class_name
+//! and connecti it to the passed Setting as a new child node.
+const Setting& UI::to_child_setting( const Setting &element, const int index )
+{
+    if ( !element.isList())
+        ui_error( "only TypeList elements could be indexed by integers", element );
+
+    if ( element.getLength() <= index )
+        ui_error( "there is not any child with index " + index, element );
+
+    return element[index];
+}
+
+const Setting& UI::to_child_setting( const Setting &element, const string &name )
+{
+    ASSERT_UITYPE(element,TypeGroup);
+    if ( !element.exists( name ) )
+        ui_error( "there is not any child named """ + name, element );
+    return element[name];
+}
+
+
+}
+
Index: /bdm/stat/libEF.cpp
===================================================================
--- /bdm/stat/libEF.cpp (revision 330)
+++ /bdm/stat/libEF.cpp (revision 357)
@@ -1,6 +1,7 @@
+#include <math.h>
 
 #include <itpp/base/bessel.h>
 #include "libEF.h"
-#include <math.h>
+#include "..\user_info.h"
 
 namespace bdm{
@@ -319,3 +320,40 @@
 }
 
+void migamma_ref::from_setting( const Setting &root ) 
+{				
+	vec ref;
+	UI::get( ref, root, "ref" );
+	set_parameters(root["k"],ref,root["l"]);
+}
+
+/*void migamma_ref::to_setting( Setting &root ) const
+{	
+	Transport::to_setting( root );
+
+	Setting &kilometers_setting = root.add("kilometers", Setting::TypeInt );
+	kilometers_setting = kilometers;
+
+	UI::save( passengers, root, "passengers" );
+}*/
+
+
+void mlognorm::from_setting( const Setting &root ) 
+{	
+	vec mu0;
+	UI::get( mu0, root, "mu0");
+	set_parameters(mu0.length(),root["k"]);
+	condition(mu0);
+}
+
+/*void mlognorm::to_setting( Setting &root ) const
+{	
+	Transport::to_setting( root );
+
+	Setting &kilometers_setting = root.add("kilometers", Setting::TypeInt );
+	kilometers_setting = kilometers;
+
+	UI::save( passengers, root, "passengers" );
+}*/
+
+
 };
Index: /bdm/stat/libDS.h
===================================================================
--- /bdm/stat/libDS.h (revision 342)
+++ /bdm/stat/libDS.h (revision 357)
@@ -90,5 +90,15 @@
 		//rowid and delays are ignored
 	};
-};
+
+	ITppFileDS () :FileDS() {
+	};
+
+	void from_setting( const Setting &root );
+
+	// TODO dodelat void to_setting( Setting &root ) const;
+
+};
+
+UIREGISTER(ITppFileDS);
 
 /*!
@@ -200,5 +210,42 @@
 	}
 
-};
+	// TODO dokumentace - aktualizovat
+	/*! UI for ArxDS using factorized description!
+
+	The ArxDS is constructed from a structure with fields:
+	\code
+	system = {
+		type = "ArxDS";
+		// description of y variables
+		y = {type="rv"; names=["y", "u"];};
+		// description of u variable
+		u = {type="rv"; names=[];}
+		// description of regressor
+		rgr = {type="rv";
+			names = ["y","y","y","u"];
+			times = [-1, -2, -3, -1];
+		}
+
+		// theta
+		theta = [0.8, -0.3, 0.4, 1.0,
+				 0.0, 0.0, 0.0, 0.0];
+		// offset (optional)
+		offset = [0.0, 0.0];
+		//variance
+		r = [0.1, 0.0,
+			 0.0, 1.0];
+		//options: L_theta = log value of theta,
+		opt = "L_theta";
+	};
+	\endcode
+
+	Result is ARX data source offering with full history as Drv.
+	*/
+	void from_setting( const Setting &root );
+
+	// TODO dodelat void to_setting( Setting &root ) const;
+};
+
+UIREGISTER( ArxDS );
 
 class stateDS : public DS {
@@ -222,4 +269,7 @@
 	stateDS ( mpdf* IM0, mpdf* OM0, int usize ) :DS ( ),IM ( IM0 ),OM ( OM0 ),
 			dt ( OM0->dimension() ), xt ( IM0->dimension() ), ut ( usize ) {}
+
+	stateDS(){}
+
 	~stateDS() {delete IM; delete OM;}
 	virtual void step() {
@@ -237,5 +287,40 @@
 	}
 
-};
+	/*! UI for stateDS 
+
+	The DS is constructed from a structure with fields:
+	\code
+	system = {
+		type = "stateDS";
+		//Internal model
+		IM = { type = "mpdf"; //<-- valid offspring! e.g. "mlnorm"
+			rv = { //description of x_t 
+				names=["name1",...];
+				sizes=[2,1]; // optional default=[1,1...];
+				times=[0,0]; // optional default=[0,0...];
+				}
+			rvu= { //description of  u_t 
+				//optional default=empty
+				}	
+
+			// remaining fields depending on the chosen type
+			};
+		//Observation model
+		OM = { type = "mpdf-offspring";
+			rv = {}; //description of d_t 
+			rvu = {type="internal", path="system.IM.rvu"}; //description of u_t 
+		
+			//remaining fields
+		}
+	};
+	\endcode
+	*/
+	void from_setting( const Setting &root );
+
+	// TODO dodelat void to_setting( Setting &root ) const;
+
+};
+
+UIREGISTER(stateDS);
 
 }; //namespace
Index: /bdm/stat/loggers.cpp
===================================================================
--- /bdm/stat/loggers.cpp (revision 347)
+++ /bdm/stat/loggers.cpp (revision 357)
@@ -26,4 +26,21 @@
 	}
 }
+
+void memlog::from_setting( const Setting &root ) 
+{	
+	// TODO tady se natvrdo ocekava existence stringu, nejsou zadne defaulty.. je to tak OK?
+	string itfilename = (string)root["filename"];
+	maxlen = root["maxlen"];
+}
+
+/*void memlog::to_setting( Setting &root ) const
+{	
+	Transport::to_setting( root );
+
+	Setting &kilometers_setting = root.add("kilometers", Setting::TypeInt );
+	kilometers_setting = kilometers;
+
+	UI::save( passengers, root, "passengers" );
+}*/
 
 void dirfilelog::init() {
@@ -62,6 +79,7 @@
 					ii++;
 				}
-			} else {
-			ii++;}
+			} 
+			else {
+				ii++;}
 		}
 	}
@@ -140,3 +158,24 @@
 }
 
+
+void dirfilelog::from_setting( const Setting &root ) 
+{	
+	// TODO tady se natvrdo ocekava existence stringu, nejsou zadne defaulty.. je to tak OK?
+	dirname = (string)root["dirname"];
+	maxlen = root["maxlen"];
+	scalarnames.set_length(0);
 }
+
+/*void dirfilelog::to_setting( Setting &root ) const
+{	
+	Transport::to_setting( root );
+
+	Setting &kilometers_setting = root.add("kilometers", Setting::TypeInt );
+	kilometers_setting = kilometers;
+
+	UI::save( passengers, root, "passengers" );
+}*/
+
+
+
+}
Index: /bdm/stat/libBM.cpp
===================================================================
--- /bdm/stat/libBM.cpp (revision 280)
+++ /bdm/stat/libBM.cpp (revision 357)
@@ -1,5 +1,4 @@
 
 #include "libBM.h"
-#include "../itpp_ext.h"
 
 //! Space of basic BDM structures
@@ -213,4 +212,40 @@
 }
 
+void RV::from_setting( const Setting &root ) 
+{	
+	Array<string> A;
+	if( root.exists("names"))
+		UI::get( A, root, "names" );
+	else
+		A.set_length(0);
+	
+	ivec szs;
+	if( root.exists("sizes"))
+		UI::get(szs,root,"sizes");
+	else
+		szs = ones_i(A.length());
+	
+	ivec tms;
+	if( root.exists( "times") )
+		UI::get(tms,root,"times");
+	else
+		tms = zeros_i(A.length());
+	
+	// TODO tady se bude plnit primo do jeho promennych, a pak se zavola validacnni metoda, takze cele prepsat, ano?
+	init( A, szs, tms );
+}
+
+/*void RV::to_setting( Setting &root ) const
+{	
+	Transport::to_setting( root );
+
+	Setting &kilometers_setting = root.add("kilometers", Setting::TypeInt );
+	kilometers_setting = kilometers;
+
+	UI::save( passengers, root, "passengers" );
+}*/
+
+
+
 RV concat ( const RV &rv1, const RV &rv2 ) {
 	RV pom = rv1;
Index: /bdm/stat/libEF.h
===================================================================
--- /bdm/stat/libEF.h (revision 330)
+++ /bdm/stat/libEF.h (revision 357)
@@ -17,5 +17,5 @@
 #include "libBM.h"
 #include "../math/chmat.h"
-//#include <std>
+#include "../user_info.h"
 
 namespace bdm
@@ -515,5 +515,64 @@
 			void set_parameters ( fnc* g0, const sq_T &R0 ) {g=g0; epdf.set_parameters ( zeros ( g->dimension() ), R0 );}
 			void condition ( const vec &cond ) {mu=g->eval ( cond );};
-	};
+
+
+			/*! UI for mgnorm
+
+			The mgnorm is constructed from a structure with fields:
+			\code
+			system = {
+				type = "mgnorm";
+				// function for mean value evolution
+				g = {type="fnc"; ... }
+
+				// variance
+				R = [1, 0,
+					 0, 1];
+				// --OR --
+				dR = [1, 1];
+
+				// == OPTIONAL ==
+
+				// description of y variables
+				y = {type="rv"; names=["y", "u"];};
+				// description of u variable
+				u = {type="rv"; names=[];}
+			};
+			\endcode
+
+			Result if
+			*/
+
+			void from_setting( const Setting &root ) 
+			{	
+				fnc* g = UI::build<fnc>( root, "g" );
+
+				mat R;
+				if ( root.exists( "dR" ) )
+				{
+					vec dR;
+					UI::get( dR, root, "dR" );
+					R=diag(dR);
+				}
+				else 
+					UI::get( R, root, "R");					
+		
+				set_parameters(g,R);
+			}
+
+			/*void mgnorm::to_setting( Setting &root ) const
+			{	
+				Transport::to_setting( root );
+
+				Setting &kilometers_setting = root.add("kilometers", Setting::TypeInt );
+				kilometers_setting = kilometers;
+
+				UI::save( passengers, root, "passengers" );
+			}*/
+
+	};
+
+	UIREGISTER(mgnorm<chmat>);
+
 
 	/*! (Approximate) Student t density with linear function of mean value
@@ -630,4 +689,5 @@
 	};
 
+
 	/*!
 	\brief  Gamma random walk around a fixed point
@@ -699,5 +759,32 @@
 				migamma::condition ( mean );
 			};
-	};
+
+			/*! UI for migamma_ref
+
+			The migamma_ref is constructed from a structure with fields:
+			\code
+			system = {
+				type = "migamma_ref";
+				ref = [1e-5; 1e-5; 1e-2 1e-3];            // reference vector
+				l = 0.999;                                // constant l
+				k = 0.1;                                  // constant k
+				
+				// == OPTIONAL ==
+				// description of y variables
+				y = {type="rv"; names=["y", "u"];};
+				// description of u variable
+				u = {type="rv"; names=[];}
+			};
+			\endcode
+
+			Result if
+			 */
+			void from_setting( const Setting &root );
+
+			// TODO dodelat void to_setting( Setting &root ) const;
+	};
+
+
+	UIREGISTER(migamma_ref);
 
 	/*! Log-Normal probability density
@@ -753,5 +840,30 @@
 				mu=log ( val )-sig2;//elem_mult ( refl,pow ( val,l ) );
 			};
-	};
+
+			/*! UI for mlognorm
+
+			The mlognorm is constructed from a structure with fields:
+			\code
+			system = {
+				type = "mlognorm";
+				k = 0.1;                                  // constant k
+				mu0 = [1., 1.];
+				
+				// == OPTIONAL ==
+				// description of y variables
+				y = {type="rv"; names=["y", "u"];};
+				// description of u variable
+				u = {type="rv"; names=[];}
+			};
+			\endcode
+
+			 */
+			void from_setting( const Setting &root );
+
+			// TODO dodelat void to_setting( Setting &root ) const;
+
+	};
+	
+	UIREGISTER(mlognorm);
 
 	/*! inverse Wishart density defined on Choleski decomposition
